#include <mega8.h>
#include <math.h>
#include <delay.h>
#define PHW 50

#define H1 PORTD.5
#define H2 PORTB.0

#define ocp_led PORTB.4
#define crg_led PORTB.5

#define ZU PORTB.3
//#define ZUon (OCR2=255)
//#define ZUoff (OCR2=15)
#define AC_switch PORTC.1
#define INV310 PORTC.0
#define INV310on (PORTC.0=1)
#define INV310off (PORTC.0=0)
#define off 0
#define on 1


//___________________________________________________________________________________
#define A PORTC.2
#define B PORTC.3                 
#define C PORTC.4
#define D PORTC.5
#define E PORTD.0
#define F PORTD.1
#define G PORTD.2
#define DP PORTD.3

#define D1 PORTD.4
#define D2 PORTB.6
#define D3 PORTB.7

const unsigned char codes[10]={0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09};
volatile unsigned char data[3]={0x00,0x00,0x00};
volatile unsigned char counter=0;
volatile unsigned int voltage; 
static unsigned int Vbat = 0;
volatile bit ac = 0, dc = 0, dcr = 0, irn = 0, bfull = 0;

//___________________________________________________________________________________
volatile unsigned char sin_table [];  
volatile unsigned char i = 0;

void sin_init (void) { 
 char s = 0; 
 float g= (PI / (PHW-1));

 do { 
 sin_table[s]=(unsigned char)(sin((float) (s * g)) * (float)(0xC8)); 
 s++; 
 } while (s<PHW); 
 }  
//___________________________________________________________________________________
void port_init ()
{
DDRB = 0b11111111;
PORTB = 0x00;

DDRD = 0b00111111;
PORTD = 0x00;

DDRC = 0b00111111;
PORTC = 0x00;

H1 = 0;
H2 = 1;  
}
//___________________________________________________________________________________
void init_ancp (void)
{
ACSR &= (~((1<<ACIS0)|(1<<ACIS1))); //interrupt on toggle   
ACSR |= ((1<<ACBG)|(1<<ACIE));   //1,22V ion on, interrupt on
}
//___________________________________________________________________________________
void ADC_Init()
{
  ADMUX = (1<<REFS1)|(1<<REFS0)|(1<<ADLAR)|(0<<MUX3)|(1<<MUX2)|(1<<MUX1)|(1<<MUX0);// Vref2,5V, left adgst, cnl7
  ADCSR = (1<<ADEN)|(0<<ADSC)|(0<<ADFR)|(0<<ADIE)|(0<<ADPS2)|(1<<ADPS1)|(1<<ADPS0); //adc on, div factor = 8 
}
//___________________________________________________________________________________________
void TC1_init ()
{
TCCR1A=0b10000001; // WGM12&WGM10 >>fast pwm 8bit 
TCCR1B=0b00001010; //  8Mhz/8
TCNT1=0x37; //initial value for ovf interrupt with 5kHz freq
}
//___________________________________________________________________________________
void init_tim2 ()
{
TCCR2=0b01101111;
TCNT2=0x00;
//TIMSK |=(1<<TOIE2);
OCR2 = 0;
TCCR2 &= (~(1<<COM21));
//TIMSK |=0x40;  //0b01000000
}
//___________________________________________________________________________________
void watchdog_on ()
{
#pragma optsize-
WDTCR=0x18; //0b00011000  wd change enable, wd enable
WDTCR=0x0E; //0b00001110  wd enable, 1s
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif
}
//___________________________________________________________________________________
void watchdog_off ()
{
#pragma optsize-
WDTCR=0x18; //0b00011000  wd change enable, wd enable
WDTCR=0x00; //wd disable
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif
}
//___________________________________________________________________________________ 

interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{
bit tmp1 = 0, tmp2 =0;
char tmp = 0;
TCNT1=0x37; // (1MHz/200)/100Hz >>50 ticks per half-wave
tmp |= TCCR1A;
tmp1 |= PIND.5;
tmp2 |= PINB.0;
#asm("wdr")

OCR1A = (0x38 + sin_table [i]);
OCR1B = (0x38 + sin_table [i]);
i++;
if  ( i == PHW ) {i=0; PORTD.5 = 0;  PORTB.0 = 0; TCCR1A &= (~((1<<COM1A1)|(1<<COM1B1))); delay_us (300);
    PORTD.5 = tmp2;   PORTB.0 = tmp1;  tmp ^= ((1<<7)|(1<<5));  TCCR1A = tmp; }
}
//___________________________________________________________________________________
interrupt [ANA_COMP] void ana_comp_isr(void)
{
if ((ACSR.5 == 0))  //when Ain1 (PD7)>1,22V comp out = 0
{
do  //overcurrent protection mode 
   {
    H1 = 0; H2 = 0; TCCR1A &= (~((1<<COM1A1)|(1<<COM1B1))); TIMSK &= ~(1<<TOIE1); 
    #asm("wdr"); watchdog_off (); delay_ms (5000);
    ocp_led = 1;
    } while (ACSR.5 == 0); //turn off hi fets, disconnect both tcnt1 out, stop tcnt1
}   
if (ACSR.5)  { i = 0; H1 = 0; H2 = 1; TCCR1A &= (~(1<<COM1B1)); TCCR1A |=(1<<COM1A1); TIMSK |= (1<<TOIE1);
                     ocp_led = 0; watchdog_on ();}

}
//___________________________________________________________________________________

void clear_display ()
{
 A=1; B=1; C=1; D=1; E=1; F=1; G=1; DP=1; D1=0; D2=0; D3=0;
}
//___________________________________________________________________________________________
void write_code ()
{
switch (data[counter])
   {
      case 0:            (A=0),(B=0),(C=0),(D=0),(E=0),(F=0);           break;
      case 1:            (B=0),(C=0);                                                   break;
      case 2:            (A=0),(B=0),(D=0),(E=0),(G=0);                     break;
      case 3:            (A=0),(B=0),(C=0),(D=0),(G=0);                     break;
      case 4:            (B=0),(C=0),(F=0),(G=0);                               break;
      case 5:            (A=0),(C=0),(D=0),(F=0),(G=0);                     break;
      case 6:            (A=0),(C=0),(D=0),(E=0),(F=0),(G=0);           break;
      case 7:            (A=0),(B=0),(C=0);                                         break;
      case 8:            (A=0),(B=0),(C=0),(D=0),(E=0),(F=0),(G=0); break;
      case 9:            (A=0),(B=0),(C=0),(D=0),(F=0),(G=0);           break;
      default:                                                                                  break;
   }
} 
//___________________________________________________________________________________________
void enable_digit  ()
{
 switch (counter)   
    {
     case 0: (D1 = 1); break;
     case 1: (D2 = 1), (DP=0); break;
     case 2: if (data[2]) {(D3 = 1);} else {(D3 = 0);}  break;
     default:               break;
    }

}
//___________________________________________________________________________________________
void convert_data (unsigned int x)
{
 unsigned int temp,res;
 temp=x;
 res=temp/1000;//Calculate 1000-s
 data[2]=codes[res];
 temp=temp-res*1000;
 res=temp/100;//Calculate 100-s  
 data[1]=codes[res];
 temp=temp-res*100;
 res=temp/10;//Calculaate 10-s
 data[0]=codes[res];
}
 //___________________________________________________________________________________________
 unsigned int get_adc (void) //reed adc results
{
  unsigned int adcTemp = 0;
  unsigned int adcValue = 0;
  unsigned char count = 0;
  
for (count=0; count < 8; count++) 
{
ADCSR |= (1<<ADSC);//adc start conversion
while (ADCSR.6 != 0x00); //wait for conversion complete
   adcTemp = ADCH; //8bit precision
   adcValue = adcValue + adcTemp;
}
    adcValue = (adcValue >> 3); // /8 for get average conversion result
    return adcValue;
}
//___________________________________________________________________________________________
void  calculate_voltage ()
{
    voltage = get_adc();
    voltage = ((unsigned long)voltage * 1800)/255; //Vbat calculation
}
//___________________________________________________________________________________ 
void display ()
{
 clear_display ();
 enable_digit ();
 write_code ();
 counter=(counter+1)%3;//Increment digit counter 
}
//___________________________________________________________________________________________
char check_AC ()
{
unsigned char ac220 = 0;
ADMUX &= (~(1<<MUX0));// switch to adc6 
ac220 = get_adc();
ADMUX |= (1<<MUX0);// switch back to adc7
if (ac220 > 127) return 1;
else return 0;
}
//___________________________________________________________________________________ 
char check_DC ()
{
unsigned char dc12 = 0;
dc12 = get_adc ();
if (dc12 > 166) return 1;
else return 0;
}
//___________________________________________________________________________________ 
char check_DCR ()
{
unsigned char dc12 = 0;
dc12 = get_adc ();
if (dc12 > 177) return 1;
else return 0;
}
//___________________________________________________________________________________ 
 void ZU_on ()
 {
    OCR2 = 255;
    TCCR2 |= (1<<COM21);
    crg_led = 1;
 }
 //___________________________________________________________________________________
  void ZU_off ()
 {
    OCR2 = 0;
    TCCR2 &= (~(1<<COM21));
    crg_led = 0;
 }
//___________________________________________________________________________________
void ZU_stb ()
{
    if (Vbat > 226) { OCR2 = 0;}
    else if (Vbat > 190) { OCR2 = 15;}    
    else if (Vbat > 180) { OCR2 = 45;}  
    else if (Vbat >= 170) { OCR2 = 75;}
    TCCR2 |= (1<<COM21);
    crg_led = 0;
}
//___________________________________________________________________________________
void charger ()
{
    
     
     ac = check_AC ();    
     if  (ac == 1) 
    {
     Vbat = get_adc ();
     if (Vbat < 85) {ZU_off (); bfull = 0;}
     else if (Vbat > 226) {ZU_off (); bfull = 1;}
     else if ((Vbat >= 85)&(Vbat < 165)) {ZU_on (); bfull = 0;}
     else if ((Vbat >= 170)&(bfull == 1)) {ZU_stb ();} 
     else if (Vbat >= 165) {ZU_on ();}    
    }
    if (ac == 0)  {ZU_off ();} 
}
//___________________________________________________________________________________ 

void inv_stop  (void)
{
H1 = 0; H2 = 0; TCCR1A &= (~((1<<COM1A1)|(1<<COM1B1))); TIMSK &= ~(1<<TOIE1); 
watchdog_off (); delay_ms (5000);
irn = 0; i = 0;
}
//___________________________________________________________________________________ 
void inv_run (void)
{
H1 = 0; H2 = 1; TCCR1A &= (~(1<<COM1B1)); TCCR1A |=(1<<COM1A1); TIMSK |= (1<<TOIE1);
irn = 1;  i = 0;
watchdog_on (); 
} 
//___________________________________________________________________________________
void DC310 (void) 
{
    #asm("wdr")
    ac = check_AC ();    
    dc = check_DC ();
    dcr = check_DCR ();
if ((ac == 1)|(ocp_led == 1))
    {
     AC_switch = 0;
     #asm("wdr");
     watchdog_off ();
     delay_ms (1000);
     INV310off;
     watchdog_on ();
     if (irn == 1) inv_stop ();    
    }
else if ((dcr == 1)&(ac == 0)&(ocp_led == 0))
    {
      if (irn == 0) {inv_run ();}
      INV310on;
      #asm("wdr");
      watchdog_off ();
      delay_ms (1000); 
      watchdog_on ();
      AC_switch = 1;      
    }
else if ((dc == 0)&(ac == 0))
    {
     if (irn == 1) {inv_stop ();}
     AC_switch = 0;
     #asm("wdr");
     watchdog_off ();
     delay_ms (1000);
     watchdog_on ();
     INV310off; 
    }     
}
//___________________________________________________________________________________
void sleep ()
{
 AC_switch = 0;
 inv_stop ();
 INV310off;
 ZU_off ();
 clear_display ();
 #asm("wdr");
 watchdog_off ();
 delay_ms (6000);
 watchdog_on ();
}
//___________________________________________________________________________________



void main(void)
{
 AC_switch = 0;
 INV310 = 0;
port_init ();
sin_init ();
init_ancp ();
ADC_Init ();
TC1_init ();
init_tim2 ();
irn = 1;

TIMSK=0b00000100;  //TOIE1 = 1



 #asm("sei")


while (1)
      {
    ac = check_AC ();    
    dc = check_DC ();
    dcr = check_DCR ();
    if ((dc == 0)&(ac == 0) )
    { sleep ();}
    else if ((dcr == 1)&(ac == 0)&(irn == 0)&(ocp_led == 0))
    {inv_run (); ZU_off ();}
     #asm("wdr")
            calculate_voltage ();
            convert_data (voltage);
            display ();

    
    if (ac == 1)            {charger ();} 
    
    if (ocp_led == 0)    {DC310 ();}

}
}


